"""
******************************
 Mattie EventScripts v1.5.0.000+
  High Ping Kicker
      for Counter-Strike: Source

 * Description:
   HPK!


 * Install instructions:
       1. Install Mattie's EventScripts plugins:
           http://mattie.info/cs

       2. Copy and upload this script to:
           cstrike/addons/eventscripts/hpk/hpk.py

       3. Add the following line somewhere in autoexec.cfg:
           es_load hpk

 DONT EDIT ANYTHING IN THIS FILE!!

******************************
"""

import es
import gamethread
import keyvalues
import langlib
import os.path

ping_max = 300
ping_check_freq = 10
ping_max_check = 5
ping_warn_player = 1
ping_publicmsg = 1
ping_admins = 0
ping_settings = {'hpk_max_ping': [300, 'Max Ping'], 'hpk_check_freq': [10, 'Check every x seconds'], 'hpk_max_check': [5, 'Max checks before a player gets kicked'], 'hpk_warn_player': [1, 'Warn the player if his ping is too high'], 'hpk_publicmsg': [1, 'Public Message to announce if someone gets kicked because of high ping'], 'hpk_admins': [0, 'Admin SteamIDs for Admin Immunity']}

players = None
playerlist = None
text = None
tokens = {}

info = es.AddonInfo()
info.name = 'High Ping Kicker'
info.version = '0.1'
info.url = 'http://addons.eventscripts.com/addons/view/hpk'
info.basename = 'hpk'
info.author = 'Rio'

def load():
   global text, players, ping_max, ping_check_freq, ping_max_check, ping_warn_player, ping_publicmsg, ping_admins
   
   for option in ping_settings:
      es.ServerVar(option, ping_settings[option][0], ping_settings[option][1])
      
   if os.path.isfile(es.getAddonPath('hpk') + '/hpk_language.ini'):
      text = langlib.Strings(es.getAddonPath("hpk") + "/hpk_language.ini")
   else:
      es.dbgmsg(0, 'HPK: Unable to load hpk_language.cfg! Please ensure it is in the ./hpk/ directory.')
      
   if os.path.isfile(es.getAddonPath('hpk') + '/hpk.cfg'):
      es.server.cmd('es_xmexec ../addons/eventscripts/hpk/hpk.cfg')
   else: 
      es.dbgmsg(0, 'HPK: Unable to load hpk.cfg! Please ensure it is in the ./hpk/ directory.')
 
   ping_max = es.ServerVar('hpk_max_ping')
   ping_check_freq = es.ServerVar('hpk_check_freq')
   ping_max_check = es.ServerVar('hpk_max_check')
   ping_warn_player = es.ServerVar('hpk_warn_player')
   ping_publicmsg = es.ServerVar('hpk_publicmsg')
   ping_admins = es.ServerVar('hpk_admins')

   es.keygroupcreate("hpk_players")
   players = keyvalues.getKeyGroup("hpk_players")
   
   gamethread.delayedname(ping_check_freq, "checkping", checkping)
   
def player_activate(event_var):
   exists = es.exists("key", "hpk_players", event_var["userid"])
   if exists == 0:
      es.keycreate("hpk_players", event_var["userid"])
      es.keysetvalue("hpk_players", event_var["userid"], "ping_check", "0")

def player_disconnect(event_var):
   exists = es.exists("key", "hpk_players", event_var["userid"])
   if exists == 0:
      es.keydelete("hpk_players", event_var["userid"])

def unload():
   es.keygroupdelete("hpk_players")
   es.keygroupdelete("hpk_playerlist")

   gamethread.cancelDelayed("checkping")

def checkping():
   es.keygroupcreate("hpk_playerlist")
   es.server.cmd("es_xcreateplayerlist hpk_playerlist")  
   playerlist = keyvalues.getKeyGroup("hpk_playerlist")
   
   for k in playerlist:
      checkplayerping(k)
      
   es.keygroupdelete("hpk_playerlist")
   gamethread.delayedname(ping_check_freq, "checkping", checkping)
   
def checkplayerping(k):
   userid = k.getName()
   username = k["name"]
   steamid = k["steamid"]
   steamid = "%s;" % steamid

   ping_check = es.keygetvalue("hpk_players", userid, "ping_check") 
   
   if ping_check is None:
      ping_check = 0

   if k["ping"] >= ping_max and str(steamid) not in str(ping_admins):   
      es.keysetvalue("hpk_players", userid, "ping_check", (int(ping_check) + 1))
      
      if ping_warn_player == 1:
         tokens['ping_check'] = ping_check
         tokens['ping_max_check'] = ping_max_check
         es.tell(userid, "#multi", text("ping_warnmsg", tokens))
      
      if int(ping_check) >= ping_max_check:
         if ping_publicmsg == 1:
            tokens['username'] = username
            tokens['ping_max'] = ping_max
            es.msg(text("ping_publicmsg", tokens))
      
         es.server.cmd("kickid %i %s" % (int(userid), text("ping_kickmsg")))      
   else:
      if int(ping_check) > 0:
         es.keysetvalue("hpk_players", userid, "ping_check", (int(ping_check) - 1))